﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

  Private bogusData As New BindingList(Of someObject)

  Public Sub New()

    ' This call is required by the designer.
    InitializeComponent()

    ' Add any initialization after the InitializeComponent() call
    PopulateSomeData()
    UltraGrid1.DataSource = bogusData
  End Sub

  Public Sub PopulateSomeData()
    bogusData.Add(New someObject With {.ID = 1, .First = "Joe", .Last = "King", .SomeBoolean = True})
    bogusData.Add(New someObject With {.ID = 2, .First = "Bob", .Last = "Cat", .SomeBoolean = False})
    bogusData.Add(New someObject With {.ID = 3, .First = "Sierra", .Last = "Nevada", .SomeBoolean = True})
    bogusData.Add(New someObject With {.ID = 4, .First = "Chocos", .Last = "R'awsum", .SomeBoolean = True})
    bogusData.Add(New someObject With {.ID = 5, .First = "Hayden", .Last = "Mitzen", .SomeBoolean = True})
    bogusData.Add(New someObject With {.ID = 6, .First = "Lulu", .Last = "Yancy", .SomeBoolean = True})
    bogusData.Add(New someObject With {.ID = 7, .First = "Bob", .Last = "Radley", .SomeBoolean = False})
  End Sub

  Private Sub UltraGrid1_AfterRowActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles UltraGrid1.AfterRowActivate
    Dim activeRow = UltraGrid1.ActiveRow

    ' In the above data, there's a duplicate first name, Bob.
    ' Both rows with the first name Bob should be selected when one of them is selected.
    For Each r In UltraGrid1.Rows
      If r.Cells("First").Text = activeRow.Cells("First").Text Then
        r.Selected = True
        'Also tried this
        'UltraGrid1.Selected.Rows.Add(r)
      End If
    Next
  End Sub

  Private Sub UltraGrid1_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
    With UltraGrid1.DisplayLayout
      .Override.CellClickAction = CellClickAction.RowSelect
    End With
  End Sub

End Class
